{% extends 'base.html.twig' %}
{% form_theme createForm 'bootstrap_4_horizontal_layout.html.twig' %}

{% block title %}
    {% if isUpdate %}
        Event Update
        {% else %}
            Event Creation
    {% endif %}

{% endblock %}
{% block stylesheets %}

{% endblock %}
{% block body %}
    {{ form_start(createForm) }}
    <div class="container">
        <h1 class="h3 mb-3 font-weight-normal">Create event</h1>
        <table class="col-md-12">
            <tr class="row">
                <td class="col-md-6">{{ form_row(createForm.name) }}</td>
                <td class="col-md-6">{{ form_row(createForm.site) }}</td>
            </tr>
            <tr class="row">
                <td class="col-md-6"> {{ form_row(createForm.startDatetime) }}</td>
                <td class="col-md-6">
                    {{ form_row(createForm.city) }}
                    <button class="btnPlus addPlace" id="addCity">+</button>
                    {{ form_row(createForm.newCity, { 'attr': {'readonly': true} }) }}
                </td>


            </tr>
            <tr class="row">
                <td class="col-md-6">{{ form_row(createForm.registrationDeadline) }}</td>
                <td class="col-md-6">
                    {{ form_row(createForm.cityType.postCode) }}
                </td>
            </tr>
            <tr class="row">
                <td class="col-md-6">{{ form_row(createForm.maxUserNumber) }}</td>
                <td class="col-md-6">
                    {{ form_row(createForm.placeSelect) }}
                    <button class="btnPlus addPlace" id="addPlace">+</button>
                    <label class="col-form-label col-sm-2" for="event_newCity">New place</label>
                </td>
            </tr>
            <tr class="row">
                <td class="col-md-6"> {{ form_row(createForm.duration) }}</td>
                <td class="col-md-6">{{ form_row(createForm.place) }} </td>
            </tr>
            <tr class="row">
                <td class="col-md-7 col-lg-6"> {{ form_row(createForm.description) }}</td>
            </tr>
            <tr class="row offset-md-2">
                <td class="col-md-3 col-3">
                    {{ form_widget(createForm.save) }}
                </td>
                <td class="col-md-3 col-3">
                    {{ form_widget(createForm.publish) }}
                </td>
                {% if isUpdate %}
                    <td class="col-md-3 col-3">
                            <a class="btn btn-lg btn-danger btnFormUpdate" href="{{ path('event_delete', {id: app.request.get('id') }) }}">Delete</a>
                    </td>
                {% endif %}
                <td class="col-md-3 col-3">
                    <a class="btn btn-lg btn-primary btnFormUpdate" href="{{ path('event') }}">Cancel</a>
                </td>

            </tr>
            <input id="newPlace" type="hidden" value="false">
        </table>
    </div>

    {% do createForm.users.setRendered %}
    {% do createForm.organizer.setRendered %}
    {% do createForm.cityType.setRendered %}
    {{ form_end(createForm) }}


{% endblock %}

{% block javascript %}

<script>
    var places;
    {% if app.request.get('id') %}
     var id = {{ app.request.get('id') }}
    {% else %}
     var id = null
    {% endif %}


    if(id){
        {% if event.place.id is defined %}
            {% if event.place.id is not null %}
            var idPlace ={{ event.place.id }}
            {% endif %}
        {% endif %}
        {% if event.place.city.id is defined %}
            var idCity = {{ event.place.city.id }}
        {% endif %}
    }

    window.onload = function(){
         if(id){
              $('#event_city').val(idCity)
         }
         ajaxCall($("#event_city option:selected").text());
    }

    function fillPlaceFields(){
        if($("#event_placeSelect")[0].value != 0){
            $.each(places,function(key, value){
                if(value.id == $("#event_placeSelect").prop('value')){

                    $("#event_place_name")[0].value = value.name
                    $("#event_place_street")[0].value = value.street
                    $("#event_place_latitude")[0].value = value.latitude
                    $("#event_place_longitude")[0].value = value.longitude
                }
            })
        }else{
            $("#event_place_name")[0].value = ''
            $("#event_place_street")[0].value = ''
            $("#event_place_latitude")[0].value = ''
            $("#event_place_longitude")[0].value = ''
        }
    }

    function ajaxCall($name){
        if($name != ''){
            var iSelectedPlace = $("#event_placeSelect option:selected").val()
            fetch('{{path('places_by_city')}}',{
                                          method: "POST",
                                          body: $name
                                        })
            .then(function (response) {
                response.json().then(function(json) {
                    places = json.places
                    $("#event_cityType_postCode").prop('readonly', true);
                    $("#event_placeSelect").empty()
                    $("#event_placeSelect").append('<option value=' + 0 + '></option>')
                    $.each(json.places,function(key, value){
                        $("#event_placeSelect").append('<option value=' + value.id + '>' + value.name + '</option>');
                    });
                    $("#event_cityType_postCode")[0].value = json.postCode

                    if(id){
                        $('#event_placeSelect').val(idPlace)
                        fillPlaceFields()
                    }else if(iSelectedPlace != 0){
                         $('#event_placeSelect').val(iSelectedPlace)
                    }
                })

            })
        }else{
            $("#event_placeSelect").empty();
            $("#event_cityType_postCode")[0].value = ''

        }
    }

    $("#event_city").change(function(){
        $("#event_newCity")[0].value = ''
        ajaxCall($("#event_city option:selected").text());
    })

     $("#event_newCity").focus(function(){
        $('#event_city').val(0)
        $('#event_cityType_postCode')[0].value = ''
        $("#event_placeSelect").empty();

    })

    $("#event_placeSelect").change(function(){
        fillPlaceFields()
    })

    $("#addPlace").click(function(){
        $("#event_place_name").prop('value', '');
        $("#event_place_name").prop('readonly', false);

        $("#event_place_street").prop('value', '');
        $("#event_place_street").prop('readonly', false);

        $("#event_place_latitude").prop('value', '');
        $("#event_place_latitude").prop('readonly', false);

        $("#event_place_longitude").prop('value', '');
        $("#event_place_longitude").prop('readonly', false);

        $("#newPlace").value = "true"
    })

    $("#addCity").click(function(){
        $("#event_city").prop('value', '');

        $("#event_cityType_postCode").prop('value', '');
        $("#event_newCity").prop('readonly', false);
        $("#event_cityType_postCode").prop('readonly', false);

        $("#event_newCity").prop('hidden', false);

        $("#event_placeSelect").empty();
    })
</script>
{% endblock %}

